/* ------------------------------ */
/* crypt rexx                     */
/* encrypt decrypt a file         */
/* for pipe stage                 */
/* by Robert Baxter               */
/* Senior Systems Programmer      */
/* Rocky Mountain News (USA) 1994 */
/* ------------------------------ */
trace ?i
arg key
key = strip(key)
numeric digits 10
keylen = length(key)
if keylen < 4 | keylen > 12
then do
  say 'invalid or missing key'
  'stagenum'
  say 'issued from stage' rc
  say 'running stage: crypt'
  exit 99
end
'callpipe var key | xlate a2e | var key'
keyx = right(key,4,'')
keyr = c2d(keyx)
keyr = abs(keyr)
keyr = right(keyr,4,0)
rndm = random(0,9,keyr)
'readto inline'
saverc = rc
do until saverc > 0
  outline = ''
  linepos = 1
  do until linepos > length(inline)
    key2 = ''
    do cnt = 1 to keylen
      rndm = random(0,9)
      key2 = key2||rndm
    end
    'callpipe var key2 | xlate a2e | var key2'
    if length(outline) + keylen > length(inline)
    then do
      keylenw = length(inline) - length(outline)
      keychar = substr(key,1,keylenw)
      keychar2 = substr(key2,1,keylenw)
    end
    else do
      keychar = key
      keychar2 = key2
      keylenw = keylen
    end
    outchar = bitxor(substr(inline,linepos,keylenw),keychar)
    outchar = bitxor(substr(inline,linepos,keylenw),keychar2)
    outline = outline || outchar
    linepos = linepos + keylenw
  end
  'output' outline
  'readto inline'
  saverc = rc
end
