/*---------------------------------------------------------------------*/
/* Pipeline Stage Command                                              */
/* selektiert Eingabes{tze zwischen zwei Labels und }bergibt           */
/* ausgelesene S{tze dem output-stream.                                */
/*---------------------------------------------------------------------*/
parse arg start end .
start = translate(start,' ','_')
end   = translate(end,' ','_')
rrc = 0
write = 'off'
do while rrc = 0
   'readto record'                           /* get next record        */
   rrc = rc
   record = substr(record,12,133)            /* remove record-number   */
   if write = 'off',
   then do
      if find(substr(record,2,132),start) /= 0, /* if find record then */
      then do                                   /* begin write output  */
         write = 'on'
         'output' record
      end
   end
   else do
      'output' record
      if find(substr(record,2,132),end) /= 0, /* if find end-record then*/
      then do                                 /*get the next record and*/
         write = 'off'                        /* stop write output     */
         'readto record'
         recnum = space(substr(record,1,11))  /* stack the actual      */
         record = substr(record,12,133)       /* record-number         */
         'output' record
         rrc = 1
      end
   end
end
